/*----- PROTECTED REGION ID(AH501.cpp) ENABLED START -----*/
static const char *RcsId = "$Id:  $";
//=============================================================================
//
// file :        AH501.cpp
//
// description : C++ source for the AH501 and its commands.
//               The class is derived from Device. It represents the
//               CORBA servant object which will be accessed from the
//               network. All commands which can be executed on the
//               AH501 are implemented in this file.
//
// project :     AH501.
//
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// SVN only:
// $HeadURL:  $
//
// CVS only:
// $Source:  $
// $Log:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <tango.h>
#include <AH501.h>
#include <AH501Class.h>

/*----- PROTECTED REGION END -----*/


/**
 *	AH501 class description:
 *	This class implements basic "socket" IPC.
 */

//================================================================
//
//  The following table gives the correspondence
//  between command and method names.
//
//  Command name    |  Method name
//----------------------------------------------------------------
//  State           |  Inherited (no method)
//  Status          |  Inherited (no method)
//  Acq_data_avg    |  acq_data_avg
//  Acq_data_raw    |  acq_data_raw
//  Acq_data_syncr  |  acq_data_syncr
//  ReadWrite       |  read_write
//================================================================
//	Attributes managed are:
//	AcqFlag:	
//	Resolution:	
//	Channels:	
//	Range:	
//	Binary:	
//	Baudrate:	
//	Offset:	
//	Version:	
//	Channel_1:	
//	Channel_2:	
//	Channel_3:	
//	Channel_4:	




namespace AH501_ns
{
	/*----- PROTECTED REGION ID(AH501::namespace_starting) ENABLED START -----*/

	//	static initializations

	/*----- PROTECTED REGION END -----*/	//	AH501::namespace_starting



//--------------------------------------------------------
/**
 *	Method      : AH501::AH501()
 *	Description : Constructors for a Tango device
 *	              implementing the class AH501
 */
//--------------------------------------------------------
AH501::AH501(Tango::DeviceClass *cl, string &s)
 	: Tango::Device_4Impl(cl, s.c_str())
{
	/*----- PROTECTED REGION ID(AH501::constructor_1) ENABLED START -----*/
	listener=NULL;
	init_device();

	/*----- PROTECTED REGION END -----*/	//	AH501::constructor_1
}
//--------------------------------------------------------
AH501::AH501(Tango::DeviceClass *cl, const char *s)
 	: Tango::Device_4Impl(cl, s)
{
	/*----- PROTECTED REGION ID(AH501::constructor_2) ENABLED START -----*/
	listener=NULL;
	init_device();

	/*----- PROTECTED REGION END -----*/	//	AH501::constructor_2
}
//--------------------------------------------------------
AH501::AH501(Tango::DeviceClass *cl, const char *s, const char *d)
 	: Tango::Device_4Impl(cl, s, d)
{
	/*----- PROTECTED REGION ID(AH501::constructor_3) ENABLED START -----*/
	listener=NULL;
	init_device();

	/*----- PROTECTED REGION END -----*/	//	AH501::constructor_3
}


//--------------------------------------------------------
/**
 *	Method      : AH501::delete_device()()
 *	Description : will be called at device destruction or at init command
 */
//--------------------------------------------------------
void AH501::delete_device()
{
	DEBUG_STREAM << "AH501::delete_device() " << device_name << endl;
	/*----- PROTECTED REGION ID(AH501::delete_device) ENABLED START -----*/

	//	Delete device allocated objects
	
	delete [] attr_AcqFlag_read;
	delete [] attr_Resolution_read;
	delete [] attr_Channels_read;
	delete [] attr_Range_read;
	delete [] attr_Binary_read;	
	delete [] attr_Baudrate_read;
	delete [] attr_Offset_read;
	delete [] attr_Version_read;

	/*----- PROTECTED REGION END -----*/	//	AH501::delete_device
	delete[] attr_Channel_1_read;
	delete[] attr_Channel_2_read;
	delete[] attr_Channel_3_read;
	delete[] attr_Channel_4_read;
	
	
}


//--------------------------------------------------------
/**
 *	Method      : AH501::init_device()
 *	Description : //	will be called at device initialization.
 */
//--------------------------------------------------------
void AH501::init_device()
{
	DEBUG_STREAM << "AH501::init_device() create device " << device_name << endl;
	

	/*----- PROTECTED REGION ID(AH501::init_device_before) ENABLED START -----*/

	//	Initialization before get_device_property() call
	std::string s;
    //--------------------------------------------


	/*----- PROTECTED REGION END -----*/	//	AH501::init_device_before
	
	//	Get the device properties (if any) from database
	get_device_property();
	
	attr_Channel_1_read = new Tango::DevLong[1];
	attr_Channel_2_read = new Tango::DevLong[1];
	attr_Channel_3_read = new Tango::DevLong[1];
	attr_Channel_4_read = new Tango::DevLong[1];
	
	/*----- PROTECTED REGION ID(AH501::init_device) ENABLED START -----*/

	//	Initialize device
	attr_AcqFlag_read = new Tango::DevBoolean;
	attr_Resolution_read = new Tango::DevShort;
	attr_Channels_read = new Tango::DevShort;
	attr_Range_read = new Tango::DevShort;
	attr_Binary_read = new Tango::DevBoolean;	
	attr_Baudrate_read = new Tango::DevLong;
	attr_Offset_read = new Tango::DevBoolean;
	attr_Version_read = new Tango::DevString;
	

    if (!listener) {
	listener = new Listener(hostname,port);
	usleep(500000);
    }
    set_state(Tango::ON);
    cmd_with_reply_or_not = false;
    
    char cmd[129];
    // Before setting parameters let's stop the acquisition
    if (majorVersion == 1) {
    	s = listener->exec_cmd("ACQ OFF",false);
	cmd_with_reply_or_not = false;
    } else {
    	s = listener->exec_cmd("S",true);
	cmd_with_reply_or_not = true;
    }

    usleep(50000);

    // Let's read the version number
    s = listener->exec_cmd("VER ?",true);
    if (strstr(s.c_str(),"VER ")) {
	version = s.c_str();
    } else {
	version = "---";
	set_state(Tango::FAULT);
	return;
    }
    
    usleep(500000);

    // Let's set the acq mode from DB property
    if (binaryAcquisition)
    	sprintf(cmd,"BIN ON");
    else
    	sprintf(cmd,"BIN OFF");
    s = listener->exec_cmd(cmd,cmd_with_reply_or_not);
    if (strstr(s.c_str(),"NAK")) {
	set_state(Tango::FAULT);
	return;
	}
    listener->data_binary = binaryAcquisition;
    usleep(500000);

    // Let's set the range by default to 0
    sprintf(cmd,"RNG %d",0);
    s = listener->exec_cmd(cmd,cmd_with_reply_or_not);
    if (strstr(s.c_str(),"NAK")) {
	set_state(Tango::FAULT);
	return;
	}
    usleep(500000);

    // Let's set the resolution 
    sprintf(cmd,"RES %d",resolution);
    s = listener->exec_cmd(cmd,cmd_with_reply_or_not);
    if (strstr(s.c_str(),"NAK")) {
	set_state(Tango::FAULT);
	return;
	}
    listener->set_resolution(resolution);
    usleep(500000);

    // Let's set the auto acq from DB property
    if (autoAcquisition) {
	s = listener->exec_cmd("ACQ ON",cmd_with_reply_or_not);
    }
    if (strstr(s.c_str(),"NAK")) {
	set_state(Tango::FAULT);
	return;
    }

	/*----- PROTECTED REGION END -----*/	//	AH501::init_device
}



//--------------------------------------------------------
/**
 *	Method      : AH501::get_device_property()
 *	Description : Read database to initialize property data members.
 */
//--------------------------------------------------------
void AH501::get_device_property()
{
	/*----- PROTECTED REGION ID(AH501::get_device_property_before) ENABLED START -----*/

	//	Initialize property data members
	hostname="";
    port = 9999;
    readtimeout = 9999;

	/*----- PROTECTED REGION END -----*/	//	AH501::get_device_property_before


	//	Read device properties from database.
	Tango::DbData	dev_prop;
	dev_prop.push_back(Tango::DbDatum("Hostname"));
	dev_prop.push_back(Tango::DbDatum("Port"));
	dev_prop.push_back(Tango::DbDatum("Readtimeout"));
	dev_prop.push_back(Tango::DbDatum("AutoAcquisition"));
	dev_prop.push_back(Tango::DbDatum("BinaryAcquisition"));
	dev_prop.push_back(Tango::DbDatum("Resolution"));
	dev_prop.push_back(Tango::DbDatum("MajorVersion"));

	//	is there at least one property to be read ?
	if (dev_prop.size()>0)
	{
		//	Call database and extract values
		if (Tango::Util::instance()->_UseDb==true)
			get_db_device()->get_property(dev_prop);
	
		//	get instance on AH501Class to get class property
		Tango::DbDatum	def_prop, cl_prop;
		AH501Class	*ds_class =
			(static_cast<AH501Class *>(get_device_class()));
		int	i = -1;

		//	Try to initialize Hostname from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  hostname;
		else {
			//	Try to initialize Hostname from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  hostname;
		}
		//	And try to extract Hostname value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  hostname;

		//	Try to initialize Port from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  port;
		else {
			//	Try to initialize Port from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  port;
		}
		//	And try to extract Port value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  port;

		//	Try to initialize Readtimeout from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  readtimeout;
		else {
			//	Try to initialize Readtimeout from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  readtimeout;
		}
		//	And try to extract Readtimeout value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  readtimeout;

		//	Try to initialize AutoAcquisition from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  autoAcquisition;
		else {
			//	Try to initialize AutoAcquisition from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  autoAcquisition;
		}
		//	And try to extract AutoAcquisition value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  autoAcquisition;

		//	Try to initialize BinaryAcquisition from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  binaryAcquisition;
		else {
			//	Try to initialize BinaryAcquisition from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  binaryAcquisition;
		}
		//	And try to extract BinaryAcquisition value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  binaryAcquisition;

		//	Try to initialize Resolution from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  resolution;
		else {
			//	Try to initialize Resolution from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  resolution;
		}
		//	And try to extract Resolution value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  resolution;

		//	Try to initialize MajorVersion from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  majorVersion;
		else {
			//	Try to initialize MajorVersion from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  majorVersion;
		}
		//	And try to extract MajorVersion value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  majorVersion;


	}
	/*----- PROTECTED REGION ID(AH501::get_device_property_after) ENABLED START -----*/

	//	Check device property data members init
	int	i = -1;
	dev_prop[++i] << hostname;
	dev_prop[++i] << port;
	dev_prop[++i] << readtimeout;
	dev_prop[++i] << autoAcquisition;
	dev_prop[++i] << binaryAcquisition;
	dev_prop[++i] << resolution;
	dev_prop[++i] << majorVersion;
	if (Tango::Util::instance()->_UseDb==true)
		get_db_device()->put_property(dev_prop);

	/*----- PROTECTED REGION END -----*/	//	AH501::get_device_property_after

}


//--------------------------------------------------------
/**
 *	Method      : AH501::always_executed_hook()
 *	Description : method always executed before any command is executed
 */
//--------------------------------------------------------
void AH501::always_executed_hook()
{
	INFO_STREAM << "AH501::always_executed_hook()  " << device_name << endl;
	
	/*----- PROTECTED REGION ID(AH501::always_executed_hook) ENABLED START -----*/

	//	code always executed before all requests
	

	/*----- PROTECTED REGION END -----*/	//	AH501::always_executed_hook
}




//--------------------------------------------------------
/**
 *	Method      : AH501::read_attr_hardware()
 *	Description : Hardware acquisition for attributes.
 */
//--------------------------------------------------------
void AH501::read_attr_hardware(TANGO_UNUSED(vector<long> &attr_list))
{
	DEBUG_STREAM << "AH501::read_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(AH501::read_attr_hardware) ENABLED START -----*/

	//	Add your own code
	//	Add your own code here

	/*----- PROTECTED REGION END -----*/	//	AH501::read_attr_hardware

}


//--------------------------------------------------------
/**
 *	Read AcqFlag attribute
 *	Description: Continuous data acquisition\n     1     Start continuous data acquisition (default at startup)\n     0    Stop continuous data acquisition\n
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void AH501::read_AcqFlag(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AH501::read_AcqFlag(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AH501::read_AcqFlag) ENABLED START -----*/
	if (autoAcquisition) 
		*attr_AcqFlag_read = 1;
	else 
		*attr_AcqFlag_read = 0;
	attr.set_value(attr_AcqFlag_read);

	/*----- PROTECTED REGION END -----*/	//	AH501::read_AcqFlag
}
	
//--------------------------------------------------------
/**
 *	Write AcqFlag attribute values to hardware.
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------	
void AH501::write_AcqFlag(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "AH501::write_AcqFlag(Tango::Attribute &attr) entering... " << endl;
	
	//	Retrieve write value
	Tango::DevBoolean	w_val;
	attr.get_write_value(w_val);
	
	/*----- PROTECTED REGION ID(AH501::write_AcqFlag) ENABLED START -----*/
	set_state(Tango::ON);
	std::string s;
	if (w_val) {
		s = listener->exec_cmd("ACQ ON",cmd_with_reply_or_not);
	} else {
		if (majorVersion > 1)
			s = listener->exec_cmd("S",true);
		else 
			s = listener->exec_cmd("ACQ OFF",false);
	}
	if (!strstr(s.c_str(),"ACK")) {
		set_state(Tango::FAULT);
		Tango::Except::throw_exception ((const char *)"AH501",
			(const char *) "Communication error",
			(const char *)"AH501::write_AcqFlag");
	}
	autoAcquisition = w_val;

	/*----- PROTECTED REGION END -----*/	//	AH501::write_AcqFlag
}

//--------------------------------------------------------
/**
 *	Read Resolution attribute
 *	Description: Resolution of AD converters\n     16     Set resolution to 16 bits (default)\n     24     Set resolution to 24 bits\n
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void AH501::read_Resolution(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AH501::read_Resolution(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AH501::read_Resolution) ENABLED START -----*/
	set_state(Tango::ON);
	std::string s;
	// First of all shut off auto acquisition
   	stop_acquisition();

	s = listener->exec_cmd("RES ?",true);
	short local_short_value;
	if (strstr(s.c_str(),"RES ")) {
		local_short_value = atoi(strstr(s.c_str(),"RES ")+4);
		*attr_Resolution_read = local_short_value;
		attr.set_value(attr_Resolution_read);
		resolution = local_short_value;
 	        listener->set_resolution(resolution);

	} else {
		set_state(Tango::FAULT);
		Tango::Except::throw_exception ((const char *)"AH501",
			(const char *) "Communication error",
			(const char *)"AH501::read_Resolution");
	}

	/*----- PROTECTED REGION END -----*/	//	AH501::read_Resolution
}
	
//--------------------------------------------------------
/**
 *	Write Resolution attribute values to hardware.
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------	
void AH501::write_Resolution(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "AH501::write_Resolution(Tango::Attribute &attr) entering... " << endl;
	
	//	Retrieve write value
	Tango::DevShort	w_val;
	attr.get_write_value(w_val);
	
	/*----- PROTECTED REGION ID(AH501::write_Resolution) ENABLED START -----*/
	set_state(Tango::ON);

	std::string s;
	// First of all shut off auto acquisition
        stop_acquisition();
	char cmd[129];
	sprintf(cmd,"RES %ld",w_val);
	s = listener->exec_cmd(cmd,cmd_with_reply_or_not);
	if (strstr(s.c_str(),"NAK")) {
		set_state(Tango::FAULT);
		Tango::Except::throw_exception ((const char *)"AH501",
			(const char *) "Communication error",
			(const char *)"AH501::write_Resolution");
	}
	resolution = w_val;
	listener->set_resolution(resolution);

	/*----- PROTECTED REGION END -----*/	//	AH501::write_Resolution
}

//--------------------------------------------------------
/**
 *	Read Channels attribute
 *	Description: Number of channels to read\n     1      Read only one channel\n     2      Read two channels\n     4      Read all four channels (default)\n
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void AH501::read_Channels(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AH501::read_Channels(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AH501::read_Channels) ENABLED START -----*/
	set_state(Tango::ON);
	std::string s;
	// First of all shut off auto acquisition
    	stop_acquisition();
	s = listener->exec_cmd("CHN ?",true);
	DEBUG_STREAM << "read from device: "<<s<<endl; 
	if (strstr(s.c_str(),"CHN ")) {
		*attr_Channels_read = atoi(strstr(s.c_str(),"CHN ")+4);
		attr.set_value(attr_Channels_read);
	} else {
		set_state(Tango::FAULT);
		Tango::Except::throw_exception ((const char *)"AH501",
			(const char *) "Communication error",
			(const char *)"AH501::read_Channels");
	}

	/*----- PROTECTED REGION END -----*/	//	AH501::read_Channels
}
	
//--------------------------------------------------------
/**
 *	Write Channels attribute values to hardware.
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------	
void AH501::write_Channels(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "AH501::write_Channels(Tango::Attribute &attr) entering... " << endl;
	
	//	Retrieve write value
	Tango::DevShort	w_val;
	attr.get_write_value(w_val);
	
	/*----- PROTECTED REGION ID(AH501::write_Channels) ENABLED START -----*/
	set_state(Tango::ON);
	std::string s;
	// First of all shut off auto acquisition
    	stop_acquisition();
	char cmd[129];
	sprintf(cmd,"CHN %ld",w_val);
	s = listener->exec_cmd(cmd,cmd_with_reply_or_not);
	if (strstr(s.c_str(),"NAK")) {
		set_state(Tango::FAULT);
		Tango::Except::throw_exception ((const char *)"AH501",
			(const char *) "Communication error",
			(const char *)"AH501::write_Channels");
	}

	/*----- PROTECTED REGION END -----*/	//	AH501::write_Channels
}

//--------------------------------------------------------
/**
 *	Read Range attribute
 *	Description: Current Range setting\n     0      Maximum current range (default)\n     1      Intermediate Range\n     2      Minimum range\n
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void AH501::read_Range(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AH501::read_Range(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AH501::read_Range) ENABLED START -----*/
	set_state(Tango::ON);
	std::string s;
	// First of all shut off auto acquisition
    	stop_acquisition();
	s = listener->exec_cmd("RNG ?",true);
	if (strstr(s.c_str(),"RNG ")) {
		*attr_Range_read = atoi(strstr(s.c_str(),"RNG ")+4);
		attr.set_value(attr_Range_read);
	} else {
		set_state(Tango::FAULT);
		Tango::Except::throw_exception ((const char *)"AH501",
			(const char *) "Communication error",
			(const char *)"AH501::read_Channels");
	}

	/*----- PROTECTED REGION END -----*/	//	AH501::read_Range
}
	
//--------------------------------------------------------
/**
 *	Write Range attribute values to hardware.
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------	
void AH501::write_Range(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "AH501::write_Range(Tango::Attribute &attr) entering... " << endl;
	
	//	Retrieve write value
	Tango::DevShort	w_val;
	attr.get_write_value(w_val);
	
	/*----- PROTECTED REGION ID(AH501::write_Range) ENABLED START -----*/
	set_state(Tango::ON);
	std::string s;
	// First of all shut off auto acquisition
    	stop_acquisition();
	char cmd[129];
	sprintf(cmd,"RNG %d",w_val);
	s = listener->exec_cmd(cmd,cmd_with_reply_or_not);
	if (strstr(s.c_str(),"NAK")) {
		set_state(Tango::FAULT);
		Tango::Except::throw_exception ((const char *)"AH501",
			(const char *) "Communication error",
			(const char *)"AH501::write_Range");
	}

	/*----- PROTECTED REGION END -----*/	//	AH501::write_Range
}

//--------------------------------------------------------
/**
 *	Read Binary attribute
 *	Description: BIN         Data Format transmission settings\n     1     Transmission of data in binary format (default)\n     0    Transmission of data in extended-ASCII format\n
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void AH501::read_Binary(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AH501::read_Binary(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AH501::read_Binary) ENABLED START -----*/
	std::string s;
	// First of all shut off auto acquisition
    	stop_acquisition();
	s = listener->exec_cmd("BIN ?",true);
	if (strstr(s.c_str(),"BIN ")) {
		set_state(Tango::ON);
		if (strstr(strstr(s.c_str(),"BIN ")+4,"ON")) 
			*attr_Binary_read = 1;
		else 
			*attr_Binary_read = 0;
		listener->data_binary = *attr_Binary_read;
		attr.set_value(attr_Binary_read);
	} else {
		set_state(Tango::FAULT);
		Tango::Except::throw_exception ((const char *)"AH501",
			(const char *) "Communication error",
			(const char *)"AH501::read_Binary");
	}

	/*----- PROTECTED REGION END -----*/	//	AH501::read_Binary
}
	
//--------------------------------------------------------
/**
 *	Write Binary attribute values to hardware.
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------	
void AH501::write_Binary(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "AH501::write_Binary(Tango::Attribute &attr) entering... " << endl;
	
	//	Retrieve write value
	Tango::DevBoolean	w_val;
	attr.get_write_value(w_val);
	
	/*----- PROTECTED REGION ID(AH501::write_Binary) ENABLED START -----*/
	set_state(Tango::ON);
	std::string s;
	// First of all shut off auto acquisition
    	stop_acquisition();
	
	if (w_val)
		s = listener->exec_cmd("BIN ON",cmd_with_reply_or_not);
	else
		s = listener->exec_cmd("BIN OFF",cmd_with_reply_or_not);
	listener->data_binary = w_val;
	if (!strstr(s.c_str(),"ACK")) {
		set_state(Tango::FAULT);
		Tango::Except::throw_exception ((const char *)"AH501",
			(const char *) "Communication error",
			(const char *)"AH501::write_Binary");
	}

	/*----- PROTECTED REGION END -----*/	//	AH501::write_Binary
}

//--------------------------------------------------------
/**
 *	Read Baudrate attribute
 *	Description: Baudrate for communication\n     9600   throughput of 9600 bit/s\n     19200  throughput of 19200 bit/s\n     38400  throughput of 38400 bit/s\n     57600  throughput of 57600 bit/s\n     115200 throughput of 115200 bit/s (default)\n     230400 throughput of 230400 bit/s\n     460800 throughput of 460800 bit/s\n     921600 throughput of 921600 bit/s\n
 *
 *	Data type:	Tango::DevLong
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void AH501::read_Baudrate(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AH501::read_Baudrate(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AH501::read_Baudrate) ENABLED START -----*/
	set_state(Tango::ON);
	std::string s;
	// First of all shut off auto acquisition
    	stop_acquisition();
	s = listener->exec_cmd("BDR ?",true);
	if (strstr(s.c_str(),"BDR ")) {
		*attr_Baudrate_read = atoi(strstr(s.c_str(),"BDR ")+4);
		attr.set_value(attr_Baudrate_read);
	} else {
		set_state(Tango::FAULT);
		Tango::Except::throw_exception ((const char *)"AH501",
			(const char *) "Communication error",
			(const char *)"AH501::read_Baudrate");
	}

	/*----- PROTECTED REGION END -----*/	//	AH501::read_Baudrate
}
	
//--------------------------------------------------------
/**
 *	Write Baudrate attribute values to hardware.
 *
 *	Data type:	Tango::DevLong
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------	
void AH501::write_Baudrate(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "AH501::write_Baudrate(Tango::Attribute &attr) entering... " << endl;
	
	//	Retrieve write value
	Tango::DevLong	w_val;
	attr.get_write_value(w_val);
	
	/*----- PROTECTED REGION ID(AH501::write_Baudrate) ENABLED START -----*/
	set_state(Tango::ON);
	std::string s;
	// First of all shut off auto acquisition
    	stop_acquisition();
	char cmd[129];
	sprintf(cmd,"BDR %d",w_val);
	s = listener->exec_cmd(cmd,cmd_with_reply_or_not);
	if (strstr(s.c_str(),"NAK")) {
		set_state(Tango::FAULT);
		Tango::Except::throw_exception ((const char *)"AH501",
			(const char *) "Communication error",
			(const char *)"AH501::write_Baudrate");
	}

	/*----- PROTECTED REGION END -----*/	//	AH501::write_Baudrate
}

//--------------------------------------------------------
/**
 *	Read Offset attribute
 *	Description: Offset Correction for ASCII Data (available only in BIN OFF mode)\n     1     Correction of data format (data are transmitted as decimal numbers, always referred to 24 bit)\n     0    Transmission of data in extended-ASCII hex format with no-correction (default)\n
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void AH501::read_Offset(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AH501::read_Offset(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AH501::read_Offset) ENABLED START -----*/
	std::string s;
	// First of all shut off auto acquisition
    	stop_acquisition();
	s = listener->exec_cmd("DEC ?",true);
	if (strstr(s.c_str(),"DEC ")) {
		set_state(Tango::ON);
		if (strstr(strstr(s.c_str(),"DEC ")+4,"ON")) 
			*attr_Offset_read = 1;
		else 
			*attr_Offset_read = 0;
		attr.set_value(attr_Offset_read);
	} else {
		set_state(Tango::FAULT);
		Tango::Except::throw_exception ((const char *)"AH501",
			(const char *) "Communication error",
			(const char *)"AH501::read_Offset");
	}

	/*----- PROTECTED REGION END -----*/	//	AH501::read_Offset
}
	
//--------------------------------------------------------
/**
 *	Write Offset attribute values to hardware.
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------	
void AH501::write_Offset(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "AH501::write_Offset(Tango::Attribute &attr) entering... " << endl;
	
	//	Retrieve write value
	Tango::DevBoolean	w_val;
	attr.get_write_value(w_val);
	
	/*----- PROTECTED REGION ID(AH501::write_Offset) ENABLED START -----*/
	set_state(Tango::ON);
	std::string s;
	// First of all shut off auto acquisition
    	stop_acquisition();
	if (w_val)
		s = listener->exec_cmd("DEC ON",cmd_with_reply_or_not);
	else
		s = listener->exec_cmd("DEC OFF",cmd_with_reply_or_not);
	if (!strstr(s.c_str(),"ACK")) {
		set_state(Tango::FAULT);
		Tango::Except::throw_exception ((const char *)"AH501",
			(const char *) "Communication error",
			(const char *)"AH501::write_Offset");
	}

	/*----- PROTECTED REGION END -----*/	//	AH501::write_Offset
}

//--------------------------------------------------------
/**
 *	Read Version attribute
 *	Description: Offset Correction for ASCII Data (available only in BIN OFF mode)\n     1     Correction of data format (data are transmitted as decimal numbers, always referred to 24 bit)\n     0    Transmission of data in extended-ASCII hex format with no-correction (default)\n
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void AH501::read_Version(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AH501::read_Version(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AH501::read_Version) ENABLED START -----*/
	attr.set_value( (Tango::DevString *)&version);

	/*----- PROTECTED REGION END -----*/	//	AH501::read_Version
}

//--------------------------------------------------------
/**
 *	Read Channel_1 attribute
 *	Description: 
 *
 *	Data type:	Tango::DevLong
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void AH501::read_Channel_1(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AH501::read_Channel_1(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AH501::read_Channel_1) ENABLED START -----*/

	long data_buffer[NUM_SIGNALS];
	if (!listener->data_binary) {
		listener->get_one_shot_data(data_buffer);
		// Reading one shot data stops the autoacquisition, let's memorize it
		autoAcquisition = false;
	} else {
		if (!autoAcquisition) {
			listener->exec_cmd("ACQ ON",false);
			autoAcquisition = true;
			usleep(AFTER_ACQOFF_DELAY);
		}
		listener->read_data(data_buffer, 1);
	}
	*attr_Channel_1_read = data_buffer[0];

	//Set the attribute value
	attr.set_value(attr_Channel_1_read);

	/*----- PROTECTED REGION END -----*/	//	AH501::read_Channel_1
}

//--------------------------------------------------------
/**
 *	Read Channel_2 attribute
 *	Description: 
 *
 *	Data type:	Tango::DevLong
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void AH501::read_Channel_2(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AH501::read_Channel_2(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AH501::read_Channel_2) ENABLED START -----*/
	long data_buffer[NUM_SIGNALS];
	if (!listener->data_binary) {
		listener->get_one_shot_data(data_buffer);
		// Reading one shot data stops the autoacquisition, let's memorize it
		autoAcquisition = false;
	} else {
		if (!autoAcquisition) {
			listener->exec_cmd("ACQ ON",false);
			autoAcquisition = true;
			usleep(AFTER_ACQOFF_DELAY);
		}
		listener->read_data(data_buffer, 1);
	}
	*attr_Channel_2_read = data_buffer[1];

	//	Set the attribute value
	attr.set_value(attr_Channel_2_read);

	/*----- PROTECTED REGION END -----*/	//	AH501::read_Channel_2
}

//--------------------------------------------------------
/**
 *	Read Channel_3 attribute
 *	Description: 
 *
 *	Data type:	Tango::DevLong
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void AH501::read_Channel_3(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AH501::read_Channel_3(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AH501::read_Channel_3) ENABLED START -----*/

	long data_buffer[NUM_SIGNALS];
	if (!listener->data_binary) {
		listener->get_one_shot_data(data_buffer);
		// Reading one shot data stops the autoacquisition, let's memorize it
		autoAcquisition = false;
	} else {
		if (!autoAcquisition) {
			listener->exec_cmd("ACQ ON",false);
			autoAcquisition = true;
			usleep(AFTER_ACQOFF_DELAY);
		}
		listener->read_data(data_buffer, 1);
	}
	*attr_Channel_3_read = data_buffer[2];
	//	Set the attribute value
	attr.set_value(attr_Channel_3_read);

	/*----- PROTECTED REGION END -----*/	//	AH501::read_Channel_3
}

//--------------------------------------------------------
/**
 *	Read Channel_4 attribute
 *	Description: 
 *
 *	Data type:	Tango::DevLong
 *	Attr type:	Scalar 
 */
//--------------------------------------------------------
void AH501::read_Channel_4(Tango::Attribute &attr)
{
	DEBUG_STREAM << "AH501::read_Channel_4(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(AH501::read_Channel_4) ENABLED START -----*/

	long data_buffer[NUM_SIGNALS];
	if (!listener->data_binary) {
		listener->get_one_shot_data(data_buffer);
		// Reading one shot data stops the autoacquisition, let's memorize it
		autoAcquisition = false;
	} else {
		if (!autoAcquisition) {
			listener->exec_cmd("ACQ ON",false);
			autoAcquisition = true;
			usleep(AFTER_ACQOFF_DELAY);
		}
		listener->read_data(data_buffer, 1);
	}
	*attr_Channel_4_read = data_buffer[3];
	//	Set the attribute value
	attr.set_value(attr_Channel_4_read);

	/*----- PROTECTED REGION END -----*/	//	AH501::read_Channel_4
}



//--------------------------------------------------------
/**
 *	Method      : AH501::add_dynamic_attributes()
 *	Description : Create the dynamic attributes if any at server startup
 *	              for specified device.
 */
//--------------------------------------------------------
void AH501::add_dynamic_attributes()
{
	
	/*----- PROTECTED REGION ID(AH501::add_dynamic_attributes) ENABLED START -----*/

	//	Add your own code to create and add dynamic attributes if any

	/*----- PROTECTED REGION END -----*/	//	AH501::add_dynamic_attributes()
}



//========================================================
//	Command execution methods
//========================================================

//--------------------------------------------------------
/**
 *	Execute the Acq_data_avg command:
 *	Description: Returns an array of long values that are the average of last arg_in data.
 *
 *	@param argin Average filter size.
 *	@returns Array of averaged data.
 */
//--------------------------------------------------------
Tango::DevVarLongArray *AH501::acq_data_avg(Tango::DevShort argin)
{
	DEBUG_STREAM << "AH501::Acq_data_avg()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AH501::acq_data_avg) ENABLED START -----*/

	//	Add your own code
	//	POGO has generated a method core with argout allocation.
	//	If you would like to use a static reference without copying,
	//	See "TANGO Device Server Programmer's Manual"
	//		(chapter : Writing a TANGO DS / Exchanging data)
	//------------------------------------------------------------
	Tango::DevVarLongArray	*argout  = new Tango::DevVarLongArray();
	argout->length(1);
	(*argout)[0] = 0;
	DEBUG_STREAM << "AH501::acq_data_avg(): entering... !" << endl;

	//	Add your own code to control device here
	if (!autoAcquisition) {
		std::string s;
		s = listener->exec_cmd("ACQ ON",cmd_with_reply_or_not);
		autoAcquisition = true;
		usleep(AFTER_ACQOFF_DELAY);
	}
	long data_buffer[NUM_SIGNALS];
	listener->read_data(data_buffer, argin);
	argout->length(NUM_SIGNALS);
	for (int i=0; i < NUM_SIGNALS; i++)
		(*argout)[i] = data_buffer[i];
   	//argout->set_value(long_spectrum,NUM_SIGNALS);

	/*----- PROTECTED REGION END -----*/	//	AH501::acq_data_avg

	return argout;
}

//--------------------------------------------------------
/**
 *	Execute the Acq_data_raw command:
 *	Description: Returns an array of long values that are the last acquired data.
 *
 *	@param argin 
 *	@returns Array of acquired data.
 */
//--------------------------------------------------------
Tango::DevVarLongArray *AH501::acq_data_raw()
{
	DEBUG_STREAM << "AH501::Acq_data_raw()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AH501::acq_data_raw) ENABLED START -----*/

	//	Add your own code
	//	POGO has generated a method core with argout allocation.
	//	If you would like to use a static reference without copying,
	//	See "TANGO Device Server Programmer's Manual"
	//		(chapter : Writing a TANGO DS / Exchanging data)
	//------------------------------------------------------------
	Tango::DevVarLongArray	*argout  = new Tango::DevVarLongArray();
	argout->length(1);
	(*argout)[0] = 0;
	DEBUG_STREAM << "AH501::acq_data_raw(): entering... !" << endl;

	// Two cases for binay and not binay acquisition
	long data_buffer[NUM_SIGNALS];

	if (!listener->data_binary) {
		listener->get_one_shot_data(data_buffer);
		// Reading one shot data stops the autoacquisition, let's memorize it
		autoAcquisition = false;
	} else {
		if (!autoAcquisition) {
			listener->exec_cmd("ACQ ON",false);
			autoAcquisition = true;
			usleep(AFTER_ACQOFF_DELAY);
		}
		listener->read_data(data_buffer, 1);
	}
	argout->length(NUM_SIGNALS);
	for (int i=0; i < NUM_SIGNALS; i++)
		(*argout)[i] = data_buffer[i];
   	//argout->set_value(long_spectrum,NUM_SIGNALS);

	/*----- PROTECTED REGION END -----*/	//	AH501::acq_data_raw

	return argout;
}

//--------------------------------------------------------
/**
 *	Execute the Acq_data_syncr command:
 *	Description: Waits for arg_in values and returns an array of averaged data.
 *
 *	@param argin Average filter size
 *	@returns Array of averaged data.
 */
//--------------------------------------------------------
Tango::DevVarLongArray *AH501::acq_data_syncr(Tango::DevShort argin)
{
	DEBUG_STREAM << "AH501::Acq_data_syncr()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AH501::acq_data_syncr) ENABLED START -----*/

	//	Add your own code
	//	POGO has generated a method core with argout allocation.
	//	If you would like to use a static reference without copying,
	//	See "TANGO Device Server Programmer's Manual"
	//		(chapter : Writing a TANGO DS / Exchanging data)
	//------------------------------------------------------------
	Tango::DevVarLongArray	*argout  = new Tango::DevVarLongArray();
	argout->length(1);
	(*argout)[0] = 0;
	DEBUG_STREAM << "AH501::acq_data_syncr(): entering... !" << endl;

	//	Add your own code to control device here

	if (!autoAcquisition) {
		std::string s;
		s = listener->exec_cmd("ACQ ON",cmd_with_reply_or_not);
		autoAcquisition = true;
		usleep(AFTER_ACQOFF_DELAY);
	}
	long data_max_size = listener->get_buffer_size();
	if (argin > data_max_size) {
		Tango::Except::throw_exception ((const char *)"AH501",
			(const char *) "argin out of range",
			(const char *)"AH501::acq_data_syncr");
	}
	long samples;
	long data_buffer[NUM_SIGNALS];
	//pthread_mutex_lock( &mutex1 );
	listener->reset_partial_counter();
	//pthread_mutex_unlock( &mutex1 );
	argout->length(NUM_SIGNALS);
	do  {
		//pthread_mutex_lock( &mutex1 );
		samples = listener->get_partial_counter();
		//pthread_mutex_unlock( &mutex1 );
		usleep(1);
	} while ((samples < argin) && (samples < data_max_size));
		if (samples <= data_max_size) {
			listener->read_data(data_buffer, argin);
			for (int i=0; i < NUM_SIGNALS; i++)
				(*argout)[i] = data_buffer[i];
 		} else {
			Tango::Except::throw_exception ((const char *)"AH501",
				(const char *) "samples out of range",
				(const char *)"AH501::acq_data_syncr");
		}

	/*----- PROTECTED REGION END -----*/	//	AH501::acq_data_syncr

	return argout;
}

//--------------------------------------------------------
/**
 *	Execute the ReadWrite command:
 *	Description: Generic method to interact with the AH501 via line commands
 *
 *	@param argin AH501 command
 *	@returns AH501 command
 */
//--------------------------------------------------------
Tango::DevString AH501::read_write(Tango::DevString argin)
{
	DEBUG_STREAM << "AH501::ReadWrite()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(AH501::read_write) ENABLED START -----*/

	//	Add your own code
	//	POGO has generated a method core with argout allocation.
	//	If you would like to use a static reference without copying,
	//	See "TANGO Device Server Programmer's Manual"
	//		(chapter : Writing a TANGO DS / Exchanging data)
	//------------------------------------------------------------
	
	DEBUG_STREAM << "AH501::read_write(): entering... !" << endl;

	//	Add your own code to control device here
	std::string s;
	// First of all shut off auto acquisition
    	stop_acquisition();
	s = listener->exec_cmd(argin,true);
	Tango::DevString	argout= new char [s.size()+1];
	strcpy(argout, s.c_str());

	/*----- PROTECTED REGION END -----*/	//	AH501::read_write

	return argout;
}


	/*----- PROTECTED REGION ID(AH501::namespace_ending) ENABLED START -----*/

	//	Additional Methods
bool AH501::stop_acquisition(void) {
	int max_retries, retry;
	max_retries = 3;
	retry = 0;
	std::string s;
	
	if (!autoAcquisition) {
		return true;
	}
	while (retry < max_retries) {
		retry++;
		if (majorVersion > 1)
			s = listener->exec_cmd("S",true);
		else 
			s = listener->exec_cmd("ACQ OFF",false);
		usleep(AFTER_ACQOFF_DELAY);
		if (!strstr(s.c_str(),"ACK")) {
			continue;
		} else {
			autoAcquisition = false;
			return true;
		}
	}
	set_state(Tango::FAULT);
	Tango::Except::throw_exception ((const char *)"AH501",
		(const char *) "Communication error",
		(const char *)"AH501::write_Offset");
	return false;
}

	/*----- PROTECTED REGION END -----*/	//	AH501::namespace_ending
} //	namespace
