/*----- PROTECTED REGION ID(AH501Class.cpp) ENABLED START -----*/
static const char *RcsId      = "$Id:  $";
static const char *TagName    = "$Name:  $";
static const char *CvsPath    = "$Source:  $";
static const char *SvnPath    = "$HeadURL:  $";
static const char *HttpServer = "http://www.esrf.eu/computing/cs/tango/tango_doc/ds_doc/";
//=============================================================================
//
// file :        AH501Class.cpp
//
// description : C++ source for the AH501Class. A singleton
//               class derived from DeviceClass. It implements the
//               command list and all properties and methods required
//               by the name once per process.
//
// project :     AH501.
//
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// SVN only:
// $HeadURL:  $
//
// CVS only:
// $Source:  $
// $Log:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <tango.h>
#include <AH501.h>
#include <AH501Class.h>

/*----- PROTECTED REGION END -----*/

//-------------------------------------------------------------------
/**
 *	Create AH501Class singleton and
 *	return it in a C function for Python usage
 */
//-------------------------------------------------------------------
extern "C" {
#ifdef _TG_WINDOWS_

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_AH501_class(const char *name) {
		return AH501_ns::AH501Class::init(name);
	}
}


namespace AH501_ns
{


//===================================================================
//	Initialize pointer for singleton pattern
//===================================================================
AH501Class *AH501Class::_instance = NULL;

//--------------------------------------------------------
/**
 * method : 		AH501Class::AH501Class(string &s)
 * description : 	constructor for the AH501Class
 *
 * @param s	The class name
 */
//--------------------------------------------------------
AH501Class::AH501Class(string &s):DeviceClass(s)
{
	cout2 << "Entering AH501Class constructor" << endl;
	set_default_property();
	get_class_property();
	write_class_property();

	/*----- PROTECTED REGION ID(AH501::Class::constructor) ENABLED START -----*/
	

	/*----- PROTECTED REGION END -----*/	//	AH501::Class::constructor

	cout2 << "Leaving AH501Class constructor" << endl;
}


//--------------------------------------------------------
/**
 * method : 		AH501Class::~AH501Class()
 * description : 	destructor for the AH501Class
 */
//--------------------------------------------------------
AH501Class::~AH501Class()
{
	/*----- PROTECTED REGION ID(AH501::Class::destructor) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	AH501::Class::destructor

	_instance = NULL;
}


//--------------------------------------------------------
/**
 * method : 		AH501Class::init
 * description : 	Create the object if not already done.
 *                  Otherwise, just return a pointer to the object
 *
 * @param	name	The class name
 */
//--------------------------------------------------------
AH501Class *AH501Class::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new AH501Class(s);
		}
		catch (bad_alloc)
		{
			throw;
		}		
	}		
	return _instance;
}

//--------------------------------------------------------
/**
 * method : 		AH501Class::instance
 * description : 	Check if object already created,
 *                  and return a pointer to the object
 */
//--------------------------------------------------------
AH501Class *AH501Class::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}




//===================================================================
//	Command execution method calls
//===================================================================
//--------------------------------------------------------
/**
 * method : 		Acq_data_avgClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *Acq_data_avgClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "Acq_data_avgClass::execute(): arrived" << endl;

	Tango::DevShort	argin;
	extract(in_any, argin);
	return insert((static_cast<AH501 *>(device))->acq_data_avg(argin));
}
//--------------------------------------------------------
/**
 * method : 		Acq_data_rawClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *Acq_data_rawClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "Acq_data_rawClass::execute(): arrived" << endl;

	
	return insert((static_cast<AH501 *>(device))->acq_data_raw());
}
//--------------------------------------------------------
/**
 * method : 		Acq_data_syncrClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *Acq_data_syncrClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "Acq_data_syncrClass::execute(): arrived" << endl;

	Tango::DevShort	argin;
	extract(in_any, argin);
	return insert((static_cast<AH501 *>(device))->acq_data_syncr(argin));
}
//--------------------------------------------------------
/**
 * method : 		ReadWriteClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *ReadWriteClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "ReadWriteClass::execute(): arrived" << endl;

	Tango::DevString	argin;
	extract(in_any, argin);
	return insert((static_cast<AH501 *>(device))->read_write(argin));
}




//===================================================================
//	Properties management
//===================================================================

//--------------------------------------------------------
/**
 * method : 		AH501Class::get_class_property
 * description : 	Get the class property for specified name.
 *
 * @param	name  The property name
 */
//--------------------------------------------------------
Tango::DbDatum AH501Class::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, returns  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method      : AH501::AH501Class::get_default_device_property()()
 *	Description : Return the default value for device property.
 */
//--------------------------------------------------------
Tango::DbDatum AH501Class::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method      : AH501::AH501Class::get_default_class_property()()
 *	Description : Return the default value for class property.
 */
//--------------------------------------------------------
Tango::DbDatum AH501Class::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method      : AH501::AH501Class::get_class_property()
 *	Description : //	Add your own code to initialize
 */
//--------------------------------------------------------
void AH501Class::get_class_property()
{
}


//--------------------------------------------------------
/**
 *	Method      : AH501::AH501Class::set_default_property()
 *	Description : Set default property (class and device) for wizard.
 *	              For each property, add to wizard property name and description.
 *	              If default value has been set, add it to wizard property and.
 *	              store it in a DbDatum.
 */
//--------------------------------------------------------
void AH501Class::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;
	vector<string>	vect_data;
	
	//	Set Default Class Properties

	//	Set Default Device Properties

	prop_name = "Hostname";
	prop_desc = "This is the hostname of the host to connect to.";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Port";
	prop_desc = "This is the port number to connect to.";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Readtimeout";
	prop_desc = "Read timeout in milliseconds.";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "AutoAcquisition";
	prop_desc = "If true, the AH501 start auto-acquisition at startup.  NOTE : The default values is true.";
	prop_def  = "true\n";
	vect_data.clear();
	vect_data.push_back("true");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "BinaryAcquisition";
	prop_desc = "Sets at startup the BIN or the ASCII acquisition";
	prop_def  = "false\n";
	vect_data.clear();
	vect_data.push_back("false");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Resolution";
	prop_desc = "Set at startup the desired bit resolution (16 o 24)";
	prop_def  = "24\n";
	vect_data.clear();
	vect_data.push_back("24");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "MajorVersion";
	prop_desc = "Major firmware version number";
	prop_def  = "3\n";
	vect_data.clear();
	vect_data.push_back("3");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
}


//--------------------------------------------------------
/**
 *	Method      : AH501::AH501Class::write_class_property()
 *	Description : Set class description fields as property in database
 */
//--------------------------------------------------------
void AH501Class::write_class_property()
{
	//	First time, check if database used
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("AH501");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("This class implements basic \"socket\" IPC.");
	description << str_desc;
	data.push_back(description);
		
	//	put cvs or svn location
	string	filename("AH501");
	filename += "Class.cpp";
	
	// check for cvs information
	string	src_path(CvsPath);
	start = src_path.find("/");
	if (start!=string::npos)
	{
		end   = src_path.find(filename);
		if (end>start)
		{
			string	strloc = src_path.substr(start, end-start);
			//	Check if specific repository
			start = strloc.find("/cvsroot/");
			if (start!=string::npos && start>0)
			{
				string	repository = strloc.substr(0, start);
				if (repository.find("/segfs/")!=string::npos)
					strloc = "ESRF:" + strloc.substr(start, strloc.length()-start);
			}
			Tango::DbDatum	cvs_loc("cvs_location");
			cvs_loc << strloc;
			data.push_back(cvs_loc);
		}
	}
	// check for svn information
	else
	{
		string	src_path(SvnPath);
		start = src_path.find("://");
		if (start!=string::npos)
		{
			end = src_path.find(filename);
			if (end>start)
			{
				header = "$HeadURL: ";
				start = header.length();
				string	strloc = src_path.substr(start, (end-start));
				
				Tango::DbDatum	svn_loc("svn_location");
				svn_loc << strloc;
				data.push_back(svn_loc);
			}
		}
	}

	//	Get CVS or SVN revision tag
	
	// CVS tag
	string	tagname(TagName);
	header = "$Name: ";
	start = header.length();
	string	endstr(" $");
	
	end   = tagname.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strtag = tagname.substr(start, end-start);
		Tango::DbDatum	cvs_tag("cvs_tag");
		cvs_tag << strtag;
		data.push_back(cvs_tag);
	}
	
	// SVN tag
	string	svnpath(SvnPath);
	header = "$HeadURL: ";
	start = header.length();
	
	end   = svnpath.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strloc = svnpath.substr(start, end-start);
		
		string tagstr ("/tags/");
		start = strloc.find(tagstr);
		if ( start!=string::npos )
		{
			start = start + tagstr.length();
			end   = strloc.find(filename);
			string	strtag = strloc.substr(start, end-start-1);
			
			Tango::DbDatum	svn_tag("svn_tag");
			svn_tag << strtag;
			data.push_back(svn_tag);
		}
	}

	//	Get URL location
	string	httpServ(HttpServer);
	if (httpServ.length()>0)
	{
		Tango::DbDatum	db_doc_url("doc_url");
		db_doc_url << httpServ;
		data.push_back(db_doc_url);
	}

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("Device_4Impl");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	get_db_class()->put_property(data);
}




//===================================================================
//	Factory methods
//===================================================================


//--------------------------------------------------------
/**
 * method : 		AH501Class::device_factory
 * description : 	Create the device object(s)
 *                  and store them in the device list
 *
 * @param	*devlist_ptr	The device name list
 */
//--------------------------------------------------------
void AH501Class::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{

	/*----- PROTECTED REGION ID(AH501::Class::device_factory_before) ENABLED START -----*/

	//	Add your own code
	

	/*----- PROTECTED REGION END -----*/	//	AH501::Class::device_factory_before

	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
		device_list.push_back(new AH501(this, (*devlist_ptr)[i]));							 
	}

	//	Manage dynamic attributes if any
	erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		AH501 *dev = static_cast<AH501 *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}

	/*----- PROTECTED REGION ID(AH501::Class::device_factory_after) ENABLED START -----*/

	//	Add your own code
	

	/*----- PROTECTED REGION END -----*/	//	AH501::Class::device_factory_after

	
}


//--------------------------------------------------------
/**
 *	Method      : AH501::AH501Class::attribute_factory()
 *	Description : Create the attribute object(s)
 *	              and store them in the attribute list
 */
//--------------------------------------------------------
void AH501Class::attribute_factory(vector<Tango::Attr *> &att_list)
{
	/*----- PROTECTED REGION ID(AH501::Class::attribute_factory_before) ENABLED START -----*/

	//	Add your own code

	/*----- PROTECTED REGION END -----*/	//	AH501::Class::attribute_factory_before

	//	Attribute : AcqFlag
	AcqFlagAttrib	*acqflag = new AcqFlagAttrib();
	Tango::UserDefaultAttrProp	acqflag_prop;
	acqflag_prop.set_description("Continuous data acquisition\n     1     Start continuous data acquisition (default at startup)\n     0    Stop continuous data acquisition\n");
	//	label	not set for	AcqFlag
	//	unit	not set for	AcqFlag
	//	standard_unit	not set for	AcqFlag
	//	display_unit	not set for	AcqFlag
	//	format	not set for	AcqFlag
	//	max_value	not set for	AcqFlag
	//	min_value	not set for	AcqFlag
	//	max_alarm	not set for	AcqFlag
	//	min_alarm	not set for	AcqFlag
	//	max_warning	not set for	AcqFlag
	//	min_warning	not set for	AcqFlag
	//	delta_t	not set for	AcqFlag
	//	delta_val	not set for	AcqFlag

	acqflag->set_default_properties(acqflag_prop);
	acqflag->set_polling_period(0);
	acqflag->set_disp_level(Tango::OPERATOR);
	//	Not memorized

	//	AcqFlag does not fire change event
	//	AcqFlag does not fire archive event
	//	AcqFlag does not fire data_ready event

	att_list.push_back(acqflag);
	
	//	Attribute : Resolution
	ResolutionAttrib	*resolution = new ResolutionAttrib();
	Tango::UserDefaultAttrProp	resolution_prop;
	resolution_prop.set_description("Resolution of AD converters\n     16     Set resolution to 16 bits (default)\n     24     Set resolution to 24 bits\n");
	//	label	not set for	Resolution
	//	unit	not set for	Resolution
	//	standard_unit	not set for	Resolution
	//	display_unit	not set for	Resolution
	//	format	not set for	Resolution
	//	max_value	not set for	Resolution
	//	min_value	not set for	Resolution
	//	max_alarm	not set for	Resolution
	//	min_alarm	not set for	Resolution
	//	max_warning	not set for	Resolution
	//	min_warning	not set for	Resolution
	//	delta_t	not set for	Resolution
	//	delta_val	not set for	Resolution

	resolution->set_default_properties(resolution_prop);
	resolution->set_polling_period(0);
	resolution->set_disp_level(Tango::OPERATOR);
	//	Not memorized

	//	Resolution does not fire change event
	//	Resolution does not fire archive event
	//	Resolution does not fire data_ready event

	att_list.push_back(resolution);
	
	//	Attribute : Channels
	ChannelsAttrib	*channels = new ChannelsAttrib();
	Tango::UserDefaultAttrProp	channels_prop;
	channels_prop.set_description("Number of channels to read\n     1      Read only one channel\n     2      Read two channels\n     4      Read all four channels (default)\n");
	//	label	not set for	Channels
	//	unit	not set for	Channels
	//	standard_unit	not set for	Channels
	//	display_unit	not set for	Channels
	//	format	not set for	Channels
	//	max_value	not set for	Channels
	//	min_value	not set for	Channels
	//	max_alarm	not set for	Channels
	//	min_alarm	not set for	Channels
	//	max_warning	not set for	Channels
	//	min_warning	not set for	Channels
	//	delta_t	not set for	Channels
	//	delta_val	not set for	Channels

	channels->set_default_properties(channels_prop);
	channels->set_polling_period(0);
	channels->set_disp_level(Tango::OPERATOR);
	//	Not memorized

	//	Channels does not fire change event
	//	Channels does not fire archive event
	//	Channels does not fire data_ready event

	att_list.push_back(channels);
	
	//	Attribute : Range
	RangeAttrib	*range = new RangeAttrib();
	Tango::UserDefaultAttrProp	range_prop;
	range_prop.set_description("Current Range setting\n     0      Maximum current range (default)\n     1      Intermediate Range\n     2      Minimum range\n");
	//	label	not set for	Range
	//	unit	not set for	Range
	//	standard_unit	not set for	Range
	//	display_unit	not set for	Range
	//	format	not set for	Range
	//	max_value	not set for	Range
	//	min_value	not set for	Range
	//	max_alarm	not set for	Range
	//	min_alarm	not set for	Range
	//	max_warning	not set for	Range
	//	min_warning	not set for	Range
	//	delta_t	not set for	Range
	//	delta_val	not set for	Range

	range->set_default_properties(range_prop);
	range->set_polling_period(0);
	range->set_disp_level(Tango::OPERATOR);
	//	Not memorized

	//	Range does not fire change event
	//	Range does not fire archive event
	//	Range does not fire data_ready event

	att_list.push_back(range);
	
	//	Attribute : Binary
	BinaryAttrib	*binary = new BinaryAttrib();
	Tango::UserDefaultAttrProp	binary_prop;
	binary_prop.set_description("BIN         Data Format transmission settings\n     1     Transmission of data in binary format (default)\n     0    Transmission of data in extended-ASCII format\n");
	//	label	not set for	Binary
	//	unit	not set for	Binary
	//	standard_unit	not set for	Binary
	//	display_unit	not set for	Binary
	//	format	not set for	Binary
	//	max_value	not set for	Binary
	//	min_value	not set for	Binary
	//	max_alarm	not set for	Binary
	//	min_alarm	not set for	Binary
	//	max_warning	not set for	Binary
	//	min_warning	not set for	Binary
	//	delta_t	not set for	Binary
	//	delta_val	not set for	Binary

	binary->set_default_properties(binary_prop);
	binary->set_polling_period(0);
	binary->set_disp_level(Tango::OPERATOR);
	//	Not memorized

	//	Binary does not fire change event
	//	Binary does not fire archive event
	//	Binary does not fire data_ready event

	att_list.push_back(binary);
	
	//	Attribute : Baudrate
	BaudrateAttrib	*baudrate = new BaudrateAttrib();
	Tango::UserDefaultAttrProp	baudrate_prop;
	baudrate_prop.set_description("Baudrate for communication\n     9600   throughput of 9600 bit/s\n     19200  throughput of 19200 bit/s\n     38400  throughput of 38400 bit/s\n     57600  throughput of 57600 bit/s\n     115200 throughput of 115200 bit/s (default)\n     230400 throughput of 230400 bit/s\n     460800 throughput of 460800 bit/s\n     921600 throughput of 921600 bit/s\n");
	//	label	not set for	Baudrate
	//	unit	not set for	Baudrate
	//	standard_unit	not set for	Baudrate
	//	display_unit	not set for	Baudrate
	//	format	not set for	Baudrate
	//	max_value	not set for	Baudrate
	//	min_value	not set for	Baudrate
	//	max_alarm	not set for	Baudrate
	//	min_alarm	not set for	Baudrate
	//	max_warning	not set for	Baudrate
	//	min_warning	not set for	Baudrate
	//	delta_t	not set for	Baudrate
	//	delta_val	not set for	Baudrate

	baudrate->set_default_properties(baudrate_prop);
	baudrate->set_polling_period(0);
	baudrate->set_disp_level(Tango::OPERATOR);
	//	Not memorized

	//	Baudrate does not fire change event
	//	Baudrate does not fire archive event
	//	Baudrate does not fire data_ready event

	att_list.push_back(baudrate);
	
	//	Attribute : Offset
	OffsetAttrib	*offset = new OffsetAttrib();
	Tango::UserDefaultAttrProp	offset_prop;
	offset_prop.set_description("Offset Correction for ASCII Data (available only in BIN OFF mode)\n     1     Correction of data format (data are transmitted as decimal numbers, always referred to 24 bit)\n     0    Transmission of data in extended-ASCII hex format with no-correction (default)\n");
	//	label	not set for	Offset
	//	unit	not set for	Offset
	//	standard_unit	not set for	Offset
	//	display_unit	not set for	Offset
	//	format	not set for	Offset
	//	max_value	not set for	Offset
	//	min_value	not set for	Offset
	//	max_alarm	not set for	Offset
	//	min_alarm	not set for	Offset
	//	max_warning	not set for	Offset
	//	min_warning	not set for	Offset
	//	delta_t	not set for	Offset
	//	delta_val	not set for	Offset

	offset->set_default_properties(offset_prop);
	offset->set_polling_period(0);
	offset->set_disp_level(Tango::OPERATOR);
	//	Not memorized

	//	Offset does not fire change event
	//	Offset does not fire archive event
	//	Offset does not fire data_ready event

	att_list.push_back(offset);
	
	//	Attribute : Version
	VersionAttrib	*version = new VersionAttrib();
	Tango::UserDefaultAttrProp	version_prop;
	version_prop.set_description("Offset Correction for ASCII Data (available only in BIN OFF mode)\n     1     Correction of data format (data are transmitted as decimal numbers, always referred to 24 bit)\n     0    Transmission of data in extended-ASCII hex format with no-correction (default)\n");
	//	label	not set for	Version
	//	unit	not set for	Version
	//	standard_unit	not set for	Version
	//	display_unit	not set for	Version
	//	format	not set for	Version
	//	max_value	not set for	Version
	//	min_value	not set for	Version
	//	max_alarm	not set for	Version
	//	min_alarm	not set for	Version
	//	max_warning	not set for	Version
	//	min_warning	not set for	Version
	//	delta_t	not set for	Version
	//	delta_val	not set for	Version

	version->set_default_properties(version_prop);
	version->set_polling_period(0);
	version->set_disp_level(Tango::OPERATOR);
	//	Not memorized

	//	Version does not fire change event
	//	Version does not fire archive event
	//	Version does not fire data_ready event

	att_list.push_back(version);
	
	//	Attribute : Channel_1
	Channel_1Attrib	*channel_1 = new Channel_1Attrib();
	Tango::UserDefaultAttrProp	channel_1_prop;
	//	description	not set for	Channel_1
	//	label	not set for	Channel_1
	//	unit	not set for	Channel_1
	//	standard_unit	not set for	Channel_1
	//	display_unit	not set for	Channel_1
	//	format	not set for	Channel_1
	//	max_value	not set for	Channel_1
	//	min_value	not set for	Channel_1
	//	max_alarm	not set for	Channel_1
	//	min_alarm	not set for	Channel_1
	//	max_warning	not set for	Channel_1
	//	min_warning	not set for	Channel_1
	//	delta_t	not set for	Channel_1
	//	delta_val	not set for	Channel_1

	channel_1->set_default_properties(channel_1_prop);
	channel_1->set_polling_period(0);
	channel_1->set_disp_level(Tango::OPERATOR);
	//	Not memorized

	//	Channel_1 does not fire change event
	//	Channel_1 does not fire archive event
	//	Channel_1 does not fire data_ready event

	att_list.push_back(channel_1);
	
	//	Attribute : Channel_2
	Channel_2Attrib	*channel_2 = new Channel_2Attrib();
	Tango::UserDefaultAttrProp	channel_2_prop;
	//	description	not set for	Channel_2
	//	label	not set for	Channel_2
	//	unit	not set for	Channel_2
	//	standard_unit	not set for	Channel_2
	//	display_unit	not set for	Channel_2
	//	format	not set for	Channel_2
	//	max_value	not set for	Channel_2
	//	min_value	not set for	Channel_2
	//	max_alarm	not set for	Channel_2
	//	min_alarm	not set for	Channel_2
	//	max_warning	not set for	Channel_2
	//	min_warning	not set for	Channel_2
	//	delta_t	not set for	Channel_2
	//	delta_val	not set for	Channel_2

	channel_2->set_default_properties(channel_2_prop);
	channel_2->set_polling_period(0);
	channel_2->set_disp_level(Tango::OPERATOR);
	//	Not memorized

	//	Channel_2 does not fire change event
	//	Channel_2 does not fire archive event
	//	Channel_2 does not fire data_ready event

	att_list.push_back(channel_2);
	
	//	Attribute : Channel_3
	Channel_3Attrib	*channel_3 = new Channel_3Attrib();
	Tango::UserDefaultAttrProp	channel_3_prop;
	//	description	not set for	Channel_3
	//	label	not set for	Channel_3
	//	unit	not set for	Channel_3
	//	standard_unit	not set for	Channel_3
	//	display_unit	not set for	Channel_3
	//	format	not set for	Channel_3
	//	max_value	not set for	Channel_3
	//	min_value	not set for	Channel_3
	//	max_alarm	not set for	Channel_3
	//	min_alarm	not set for	Channel_3
	//	max_warning	not set for	Channel_3
	//	min_warning	not set for	Channel_3
	//	delta_t	not set for	Channel_3
	//	delta_val	not set for	Channel_3

	channel_3->set_default_properties(channel_3_prop);
	channel_3->set_polling_period(0);
	channel_3->set_disp_level(Tango::OPERATOR);
	//	Not memorized

	//	Channel_3 does not fire change event
	//	Channel_3 does not fire archive event
	//	Channel_3 does not fire data_ready event

	att_list.push_back(channel_3);
	
	//	Attribute : Channel_4
	Channel_4Attrib	*channel_4 = new Channel_4Attrib();
	Tango::UserDefaultAttrProp	channel_4_prop;
	//	description	not set for	Channel_4
	//	label	not set for	Channel_4
	//	unit	not set for	Channel_4
	//	standard_unit	not set for	Channel_4
	//	display_unit	not set for	Channel_4
	//	format	not set for	Channel_4
	//	max_value	not set for	Channel_4
	//	min_value	not set for	Channel_4
	//	max_alarm	not set for	Channel_4
	//	min_alarm	not set for	Channel_4
	//	max_warning	not set for	Channel_4
	//	min_warning	not set for	Channel_4
	//	delta_t	not set for	Channel_4
	//	delta_val	not set for	Channel_4

	channel_4->set_default_properties(channel_4_prop);
	channel_4->set_polling_period(0);
	channel_4->set_disp_level(Tango::OPERATOR);
	//	Not memorized

	//	Channel_4 does not fire change event
	//	Channel_4 does not fire archive event
	//	Channel_4 does not fire data_ready event

	att_list.push_back(channel_4);
	

	//	Create a list of static attributes
	create_static_attribute_list(get_class_attr()->get_attr_list());

	/*----- PROTECTED REGION ID(AH501::Class::attribute_factory_after) ENABLED START -----*/

	//	Add your own code

	/*----- PROTECTED REGION END -----*/	//	AH501::Class::attribute_factory_after

}



//--------------------------------------------------------
/**
 *	Method      : AH501::AH501Class::command_factory()
 *	Description : Create the command object(s)
 *	              and store them in the command list
 */
//--------------------------------------------------------
void AH501Class::command_factory()
{
	/*----- PROTECTED REGION ID(AH501::Class::command_factory_before) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	AH501::Class::command_factory_before


	
	//	Create Acq_data_avg command object
	Acq_data_avgClass	*pAcq_data_avgCmd =
		new Acq_data_avgClass("Acq_data_avg",
			Tango::DEV_SHORT, Tango::DEVVAR_LONGARRAY,
			"Average filter size.",
			"Array of averaged data.",
			Tango::OPERATOR);
	command_list.push_back(pAcq_data_avgCmd);


	
	//	Create Acq_data_raw command object
	Acq_data_rawClass	*pAcq_data_rawCmd =
		new Acq_data_rawClass("Acq_data_raw",
			Tango::DEV_VOID, Tango::DEVVAR_LONGARRAY,
			"",
			"Array of acquired data.",
			Tango::OPERATOR);
	command_list.push_back(pAcq_data_rawCmd);


	
	//	Create Acq_data_syncr command object
	Acq_data_syncrClass	*pAcq_data_syncrCmd =
		new Acq_data_syncrClass("Acq_data_syncr",
			Tango::DEV_SHORT, Tango::DEVVAR_LONGARRAY,
			"Average filter size",
			"Array of averaged data.",
			Tango::OPERATOR);
	command_list.push_back(pAcq_data_syncrCmd);


	
	//	Create ReadWrite command object
	ReadWriteClass	*pReadWriteCmd =
		new ReadWriteClass("ReadWrite",
			Tango::DEV_STRING, Tango::DEV_STRING,
			"AH501 command",
			"AH501 command",
			Tango::OPERATOR);
	command_list.push_back(pReadWriteCmd);




	/*----- PROTECTED REGION ID(AH501::Class::command_factory_after) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	AH501::Class::command_factory_after

}




//===================================================================
//	Dynamic attributes related methods
//===================================================================


//--------------------------------------------------------
/**
 * method : 		AH501Class::create_static_attribute_list
 * description : 	Create the a list of static attributes
 *
 * @param	att_list	the ceated attribute list 
 */
//--------------------------------------------------------
void AH501Class::create_static_attribute_list(vector<Tango::Attr *> &att_list)
{
	for (unsigned long i=0 ; i<att_list.size() ; i++)
	{
		string att_name(att_list[i]->get_name());
		transform(att_name.begin(), att_name.end(), att_name.begin(), ::tolower);
		defaultAttList.push_back(att_name);
	}

	cout2 << defaultAttList.size() << " attributes in default list" << endl;


	/*----- PROTECTED REGION ID(AH501::Class::create_static_att_list) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	AH501::Class::create_static_att_list

}


//--------------------------------------------------------
/**
 * method : 		AH501Class::erase_dynamic_attributes
 * description : 	delete the dynamic attributes if any.
 *
 * @param	devlist_ptr	the device list pointer
 * @param	list of all attributes
 */
//--------------------------------------------------------
void AH501Class::erase_dynamic_attributes(const Tango::DevVarStringArray *devlist_ptr, vector<Tango::Attr *> &att_list)
{
	Tango::Util *tg = Tango::Util::instance();

	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{	
		Tango::DeviceImpl *dev_impl = tg->get_device_by_name(((string)(*devlist_ptr)[i]).c_str());
		AH501 *dev = static_cast<AH501 *> (dev_impl);
		
		vector<Tango::Attribute *> &dev_att_list = dev->get_device_attr()->get_attribute_list();
		vector<Tango::Attribute *>::iterator ite_att;
		for (ite_att=dev_att_list.begin() ; ite_att != dev_att_list.end() ; ++ite_att)
		{
			string att_name((*ite_att)->get_name_lower());
			if ((att_name == "state") || (att_name == "status"))
				continue;
			vector<string>::iterator ite_str = find(defaultAttList.begin(), defaultAttList.end(), att_name);
			if (ite_str == defaultAttList.end())
			{
				cout2 << att_name << " is a UNWANTED dynamic attribute for device " << (*devlist_ptr)[i] << endl;
				Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
				dev->remove_attribute(att_list[att.get_attr_idx()],true);
				--ite_att;
			}
		}
	}
	/*----- PROTECTED REGION ID(AH501::Class::erase_dynamic_attributes) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	AH501::Class::erase_dynamic_attributes

}



	/*----- PROTECTED REGION ID(AH501::Class::Additional Methods) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	AH501::Class::Additional Methods

} //	namespace
